<template>
  <form @submit="onSubmit">
    <TextField v-model="username" inputType="text" :error="usernameError" id="username" label="نام کاربری" />
    <TextField v-model="password" inputType="password" :error="passwordError" id="password" label="رمز عبور" />
    <Button type="contained" size="lg" color="primary" @click="onSubmit">ورود</Button>
    <nuxt-link to="/register" class="register" v-ripple>
      <p class="register__text">حساب کاربری ندارید؟</p>
    </nuxt-link>
  </form>
</template>

<script>
import Button from "@/components/base/Button";
import TextField from "@/components/base/TextField";

export default {
  name: "LoginForm",
  components: {
    Button,
    TextField
  },
  data() {
    return {
      username: "",
      password: "",
      waitingForResponse: false
    };
  },
  methods: {
    async onSubmit(e) {
      e.preventDefault();
      if (this.canSendLoginRequest) {
        this.$store.dispatch("auth/login", {
          username: this.username, 
          password: this.password
        }).then(response => {
          this.$store.dispatch('notifications/push', {
            message: 'با موفقیت وارد حساب خود شدید!',
            type: 'success',
            light: true
          });
          this.$emit('success');
        }).catch(err => {
          if (err.response.status === 400) {
            this.$store.dispatch('notifications/push', {
              message: 'نام کاربری یا رمز عبور اشتباه است!',
              type: 'error'
            });
          } else {
            this.$store.dispatch('notifications/push', {
              message: 'خطا در اتصال به سرور! لطفا دقایقی دیگر دوباره تلاش کنید.',
              type: 'error',
              timeout: 3500
            });
          }
        });
      } else {
        this.$store.dispatch('notifications/push', {
          message: 'ورودی ها خود را کنترل کنید!',
          type: 'warning',
          light: true
        });
      }
    }
  },
  computed: {
    usernameError() {
      const regex = /^[A-Za-z0-9_-]{3,16}$/;
      if (this.username.length === 0) {
        return ""
      } else if (this.username.length < 3) {
        return "نام کاربری باید حداقل 3 کاراکتر باشد."  
      } else if (this.username.length > 16) {
        return "نام کاربری نمی تواند بیشتر از 16 کاراکتر باشد."
      } else if (regex.test(this.username)) {
        return ""      
      }
      return "فقط می توانید از حروف انگلیسی، عدد ، - ، _ استفاده کنید."
    },
    passwordError() {
      if (this.password.length < 5 && this.password.length !== 0) {
        return "رمز عبور باید حداقل 5 کاراکتر باشد."
      }
      return ""
    },
    canSendLoginRequest() {
      return this.isFormFilled &&
        this.areFormInputsValid &&
        !this.waitingForResponse
        ? true
        : false;
    },
    areFormInputsValid() {
      return this.usernameError || this.passwordError ? false : true;
    },
    isFormFilled() {
      return this.username && this.password ? true : false;
    }
  }
};
</script>

<style lang="stylus" scoped>
@import '~assets/styles/variables';

form 
  display: flex
  flex-direction column
  width 50%
  justify-content: center
  padding: $lg 0 $sm
  & > *:not(:last-child)
    margin-bottom: $md;

.register
  width max-content
  padding $sm 0
  align-self flex-end
</style>